﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Communication
{
    public class Data_Conversion
    {
        public static bool eCoder_Angle_Mode_Change;

        /*****************************************************************************************************************
        函数名：Information_Data_Conversion
        输入值：无
        返回值：无   
        功能说明：编码器单圈多圈位置，分辨率数据转换
        ******************************************************************************************************************/
        public static void Information_Data_Conversion()
        {
            ZeroErr_Communication.Struct_eCoder_Data.single_Turn = ZeroErr_Communication.eCoder_Information_Data[2] | ZeroErr_Communication.eCoder_Information_Data[3] << 8 | ZeroErr_Communication.eCoder_Information_Data[4] << 16;
            ZeroErr_Communication.Struct_eCoder_Data.multi_Turn = ZeroErr_Communication.eCoder_Information_Data[6] | ZeroErr_Communication.eCoder_Information_Data[7] << 8 | ZeroErr_Communication.eCoder_Information_Data[8] << 16;
            ZeroErr_Communication.Struct_eCoder_Data.resolution = ZeroErr_Communication.eCoder_Information_Data[5];  
       }

        /*****************************************************************************************************************
        函数名：Single_Turn_Conversion
        输入值：无
        返回值：无   
        功能说明：编码器单圈数据转换
        ******************************************************************************************************************/
        public static void Single_Turn_Conversion()
        {
            ZeroErr_Communication.Struct_eCoder_Data.single_Turn = ZeroErr_Communication.eCoder_Single_Turn[2] | ZeroErr_Communication.eCoder_Single_Turn[3] << 8 | ZeroErr_Communication.eCoder_Single_Turn[4] << 16;
        }

        /*****************************************************************************************************************
        函数名：eCoder_Inside_Status_Conversion
        输入值：无
        返回值：无   
        功能说明：编码器内部状态数据转换
        ******************************************************************************************************************/
        public static void eCoder_Inside_Status_Conversion()
        {
            ZeroErr_Communication.Struct_eCoder_Inside_Status_Init();
            ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_SA = ZeroErr_Communication.eCoder_Information_Data[1];
            ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_ALMC = ZeroErr_Communication.eCoder_Information_Data[9];
            ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "编码器状态:\r\n";
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_SA & 0x10) != 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "单圈启动错误\r\n";
            }
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_SA & 0x20) != 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "多圈启动错误\r\n";
            }
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_ALMC & 0x04) != 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "单圈计数错误\r\n";
            }
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_ALMC & 0x20) != 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "多圈通讯错误\r\n";
            }
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_ALMC & 0x40) != 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "电池错误\r\n";
            }
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_ALMC & 0x80) != 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "电池警告,电压低于3.05V\r\n";
            }
            if ((ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_ALMC & 0xFF) == 0 && (ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_SA & 0xFF) == 0)
            {
                ZeroErr_Communication.Struct_eCoder_Inside_Status.eCoder_Status += "正常激活状态\r\n";
            }
        }

        /*****************************************************************************************************************
        函数名：eCoder_Angle_Conversion
        输入值：无
        返回值：无   
        功能说明：编码器角度数据转换，eCoder_Angle_Mode_Change若为true，则转换单圈数据，若为false，则转换单圈数据和多圈数据
        ******************************************************************************************************************/
        public static void eCoder_Angle_Conversion()
        {
            uint resolution = ZeroErr_Communication.eCoder_Information_Data[5];
            if (resolution != 0 && eCoder_Angle_Mode_Change == false)
            {
                ZeroErr_Communication.Struct_eCoder_Data.Angle = Convert.ToDouble((ZeroErr_Communication.Struct_eCoder_Data.single_Turn / Math.Pow(2, resolution) * 360 +
                ZeroErr_Communication.Struct_eCoder_Data.multi_Turn * 360).ToString("f4"));
            }
            else if (resolution != 0 && eCoder_Angle_Mode_Change == true)
            {
                ZeroErr_Communication.Struct_eCoder_Data.Angle = Convert.ToDouble((ZeroErr_Communication.Struct_eCoder_Data.single_Turn / Math.Pow(2, resolution) * 360).ToString("f4"));
            }
        }
    }
}
